/*
 PIvy - classfor Ivy port
 v. 0.1 / september 2009
 Copyright (c) 2009-08

*/

package fr.irit.ihcs.processing;
import processing.core.*;
import java.lang.reflect.*;

import fr.dgac.ivy.*;

public class PIvy implements IvyMessageListener{
   PApplet _parent;
   Method ivyEventMethod;
   
   Ivy bus;
       
   // properties can be passed in for default values
   // otherwise default is 127.255.255.255 for ip address and 2010 for port
   
   static String ip = "127.255.255.255";
   static int port = 2010;
   static String bindmsg ="^(.*)";

   public String [] data;

   public PIvy(PApplet parent) {
     this (parent, ip, port, bindmsg);
   }
   
   public PIvy(PApplet parent, String ip_ivy)
   {
     this(parent, ip_ivy, port, bindmsg);
   }
   
   public PIvy(PApplet parent, int port_ivy)
   {
     this(parent, ip, port_ivy, bindmsg);
   }

   public PIvy(PApplet parent, String ip_ivy, int port_ivy, String bindmsg)
   {
      this._parent = parent;
      
      try
      {
        bus = new Ivy("PIvy", "PIvy - a processing agent", null);
        bus.bindMsg(bindmsg, this);
        bus.start(ip + ":" + port);
      }
      catch (IvyException ie)
      {
      }
           
      parent.registerDispose(this);
      // reflection to check whether host applet has a call for
      // public void ivyEvent(fr.irit.ihcs.processing.PIvy)
      // which would be called each time an receive event comes in
      try {
        ivyEventMethod =
        parent.getClass().getMethod("ivyEvent",
                                    new Class[] { PIvy.class });
      } catch (Exception e) {
      // no such method, or an error.. which is fine, just ignore
    }     
   }
   
   public void receive(IvyClient client, String [] args)
   {
      // System.out.println("new message received: " + args[0]);
      //  finir
      try 
      {
        data = args.clone();
        ivyEventMethod.invoke(_parent, new Object[] { this });
      }
      catch (Exception e)
      {
        String msg = "error, disabling ivyEvent()";
        System.err.println(msg);
        e.printStackTrace();
        ivyEventMethod = null;
      }
      // catch (CloneNotSupportedException cnse) {}
   }
   
   public void send(String msg)
   {
      try
      {
        bus.sendMsg(msg);
      }
      catch (IvyException ie)
      {
      }  
   }
   
   
   // Fermeture
   
   public void stop() {
    dispose();
   }  
   
   public void dispose() {
    bus.stop();   
   }
   
}
